/*
 * Interval.java
 *
 * Created on 1. duben 2007, 15:44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ukol3;
import java.util.*;
/**
 *
 * @author Vladimr ha
 */
public class Interval implements Comparable <Interval> {
    
    private SortedSet interval;
    

    /** Creates a new instance of Interval */
    public Interval(double a,double b) throws SpatneZadanyIntervalException {
// interval realnych cisel,patri do nej krajni body
        interval=new TreeSet();
        if(b<a){
            throw new SpatneZadanyIntervalException(a,b);
        }
        for(double q=a;q<=b;q++){
            Double prvek=new Double(q);
            interval.add(prvek);
        }
    }
public Interval(){
interval=new TreeSet();
// prazdny interval, jen pro overeni metody isEmpty
/**
 * Tento interval jsem definoval jako mnozinu prvku, ktera ale zadne prvky neobsahuje
 * Nejde s nim jakkoliv pracovat, pouze overit, ze je prazdny
 * Prazdny interval je ale docela tezke definovat, protoze moje Intervaly obsahuji prvky typu double a patri do nich krajni body, takze takovy interval 
 * nejde korektne vytvorit. Kdybych delal s intervalem, kam nepatri krajni body (napr."(1,1)"), pak bych ho mohl povazovat za prazdny, ale zase bych 
 * nikdy nebyl schopen mit jednoprvkovy interval (slo by pouze s cisly typu Integer)
 **/
}

    public double getZacatek()     {
        return (Double)this.interval.first();
    }
    
    public double getKonec()    {
        return (Double)this.interval.last();
    }
    public int getSize(){
        return this.interval.size();
    }
    
    public Interval sjednotit(Interval m) throws SpatneZadanyIntervalException, SjednoceniException{
        Interval sjednocen=m;
        if(m.getKonec()<this.getZacatek()){
            throw new SjednoceniException(this,m);
        }
        if(m.getZacatek()>this.getZacatek() && this.getKonec()>m.getZacatek() && m.getKonec()==this.getKonec()){
        return new Interval(this.getZacatek(), m.getKonec());
        }
        if(this.getZacatek()==m.getZacatek() && this.getKonec()<m.getKonec()){
        return new Interval(this.getZacatek(), m.getKonec());
        }
        if(m.getZacatek()<this.getZacatek() && m.getKonec()>this.getZacatek() && m.getKonec()<this.getKonec()){
            return sjednocen=new Interval(m.getZacatek(), this.getKonec());
            
        }
        if(m.getZacatek()>this.getZacatek() && m.getKonec()<this.getKonec()){
            return sjednocen=this;
        }
        if(m.getZacatek()==this.getZacatek() &&  m.getKonec()==this.getKonec()){
            return sjednocen=this;
        }
        if(m.getZacatek()>this.getZacatek() && m.getKonec()>this.getKonec() && m.getZacatek()<this.getKonec()){
            return sjednocen=new Interval(this.getZacatek(), m.getKonec());
        }
        if(m.getZacatek()>this.getKonec()){
            throw new SjednoceniException(this, m);
        }
        if(m.getZacatek()<this.getZacatek() && m.getKonec()>this.getKonec()){
            return sjednocen=m;
            
        }
        if(this.getZacatek()==m.getKonec() && m.getZacatek()<this.getZacatek()){
            return sjednocen=new Interval(m.getZacatek(),this.getKonec());
            
        }
        if(this.getKonec()==m.getZacatek() && m.getKonec()>this.getKonec()){
            return sjednocen=new Interval(this.getZacatek(), m.getKonec());
            
        }
        return sjednocen;
    }
    public boolean isEmpty(){
        return (this.interval.isEmpty());
//  <1,1> obsahuje jen prvek 1
    }
    public Interval prunik(Interval m, Pole_Intervalu a ) throws SpatneZadanyIntervalException, PocetIntervaluException, PrunikException {
        Interval q;
           q=new Interval(this.getZacatek(), this.getKonec());
        if(a.pocetIntervalu()>1){
          
             
                Interval x=new Interval(m.getZacatek(), m.getKonec());
                if(q.interval.retainAll(x.interval)){
                    q.interval.retainAll(x.interval);
              if(q.isEmpty()){
                throw new PrunikException (this, m);}
                }
                
                
        } else{
            throw new PocetIntervaluException(1);
        }
        
        return q;
    }
    public String vypis(){
        String vypsano="";
        
        vypsano="< "+this.getZacatek()+" , "+this.getKonec()+">";
        if(this.isEmpty())return "Prazdny interval";
        return vypsano;
    }
    
    public int compareTo(Interval m){
        // podle spodnich / dolnich mezi intervalu
        if(this.getZacatek()==m.getZacatek()) return 0;
        if(this.getZacatek()<m.getZacatek()) return -1;
        if(this.getZacatek()>m.getZacatek()) return 1;
        return 0;
    }
    
}

