/*
 * Kruh.java
 *
 * Created on 21. bezen 2007, 16:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ukol3;

/**
 *
 * @author balikm1
 */
public class Kruh {
    
    private double x;   // x-ova souradnice kruhu
    private double y;   // y-ova souradnice kruhu
    private double r;   // polomer kruhu
    
    /** Creates a new instance of Kruh */
    public Kruh(double x, double y, double r) {     // v konstruktoru inicializuji instancni promenne
        this.x = x;
        this.y = y;
        this.r = r;
    }
    
    public double getX()
    {
        return this.x;
    }
    
    public double getY()
    {
        return this.y;
    }
    
    public double getR()
    {
        return this.r;
    }
    
    public double vzdalenostOd(Kruh k2)  // vzdalenost stredu od stredu jineho kruhu
    {
        return Math.sqrt((this.x-k2.x)*(this.x-k2.x)+(this.y-k2.y)*(this.y-k2.y));        
    }
    
    public boolean protina(Kruh k2)     // vraci true pokud se kruhy protinaji, jinak vraci false
    {
        boolean p = true;
        
        if (this.vzdalenostOd(k2) > (this.r + k2.r)) p = false;      // lezi vne
        else if (Math.abs(this.r - k2.r) > this.vzdalenostOd(k2)) p = false; // lezi uvnitr sebe
                
        return p;
    }
    
    public String toString()
    {
        return "X: " + this.x + ", Y: " + this.y + ", r: " + this.r; 
    }
}
