/*
 * Ohradnik.java
 *
 * Created on 21. bezen 2007, 16:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ukol3;

import java.util.*;

/**
 *
 * @author balikm1
 */
public class Ohradnik {
    
    LinkedList seznamKulu;
    
    /** Creates a new instance of Ohradnik */
    public Ohradnik() {
        seznamKulu = new LinkedList();
    }
    
    public void pridejKul(Kul k)    // prida kul do seznamu
    {
        seznamKulu.add(k);
    }
    
    public Kul getKul(int i)        // vrati kul ulozeny na i-te pozici v seznamu
    {
        return (Kul)seznamKulu.get(i);
    }
    
    public int pocetKulu()          // vrati pocet kulu v seznamu
    {
        return seznamKulu.size();
    }
    
    public double delkaDratu()throws PocetOhradnikuException
    {
        if (this.pocetKulu() < 3) throw new PocetOhradnikuException(this.pocetKulu()) ;   // indikace chyby - lepe pomoci vyjimek
        
        double delka = 0;
        
        // projdu vsechny kuly, spocitam a sectu vzdalenosti od nasledujicich
        for (int i = 0; i<this.pocetKulu()-1; i++)
        {
            delka += (this.getKul(i)).vzdalenostOd(this.getKul(i+1));
        }
        // prictu vzdalenost posledniho a prvniho
        delka += (this.getKul(this.pocetKulu()-1)).vzdalenostOd(this.getKul(0));
        
        return delka;
    }
    
    public String toString()
    {
        String str = "";
        
        for (int i=0; i<this.pocetKulu(); i++)
        {
            str += (i+1) + ".Kul: " + this.getKul(i) + "\n";
        }
        
        return str;
    }
}
